// This is BSORTARR.H
// Binary Sorted Array class
// Project IMARK - a support program for indexing TeX and LaTeX documents
// (C) Jan Kybic, 1993

// Main module is IMARK.CPP where you can also find compile notes

// This module contains implementation of Binary Sorted Array
// It behaves almost in the same way as SortedArray from CLASSLIB, except
//  it uses binary search to determine the position where a new item
//  should be put. That results in a considerable efficiency gain.
// Besides this, arguments of some methods are now Sortable to avoid
// useless typecasting, as the items must be sortable anyway.

#ifndef _BSORTARR_H
#define _BSORTARR_H

#include <sortarry.h>
#include <stdlib.h>

class BSortedArray: public SortedArray
{ public:
   BSortedArray(int upper, int lower=0, sizeType aDelta=0)
    : SortedArray(upper,lower,aDelta) {} ;  // same constructor
   virtual ~BSortedArray() {} ;
   virtual void add ( Sortable &) ;         // adds new itom into array
                                            // preserving order
   virtual int findPos( const Sortable& ) const ;
             // returns index, where object should be placed
   virtual Object& findMember (const Sortable& ) const ;
             // returns the nearest object (by reference) to the one desired
} ;

#endif
// End of BSortArr.H

