// This is IMCLASS.CPP
// classes Entry and TString
// Project IMARK - a support program for indexing TeX and LaTeX documents
// (C) Jan Kybic, 1993

#include <stdlib.h>
#include <iostream.h>
#include <ctype.h>
#include "imclass.h"
#include "csort.h"
#include "imlow.h"

Entry::Entry()
{ theKey=new CString("") ;
  checkObject(theKey) ;
  theValue=new CString("") ;
  checkObject(theValue) ;
}

Entry::Entry(Entry& e)
{ theKey=new CString(*e.theKey) ;
  checkObject(theKey) ;
  theValue=new CString(*e.theValue) ;
  checkObject(theValue) ;
}


Entry::~Entry()
{ delete theKey ;
  delete theValue ;
}

void Entry::printOn(ostream& outs) const
{ outs << *theKey << "   " << *theValue << '\n' ;
}

#define BUFLEN 100

static  char buf[BUFLEN] ;

int Entry::read(istream& instr)
{
  unsigned char rep=1,*q,*p,t ;

  do {

   instr.get((unsigned char near *)buf,(int)BUFLEN) ;
   if (instr.eof()) return 0;
   if (instr.fail())
       { cerr << "!!! ERROR: Can't read from input file.\n" ; exit(1) ; }
   instr.ignore() ;  // skip LF
   for(p=(unsigned char *)buf;*p==' ';p++) ;
   if (*p!='%')
     { for(q=p;isletter(*q);q++) ;
       t=*q ; *q=0 ;
       if (q>p)
        { rep=0 ; theKey->operator =((char *)p) ;
          *q=t ;
          for(p=q;*p>' ';p++) ;
          for(;*p==' ';p++) ;
          for(q=p;*q>' ';q++) ;
          *q=0 ;
          theValue->operator =((char *)p) ;
       }
     }
    } while (rep) ;
  return 1 ;
}


void Entry::setkey(String& s)
{ theKey->operator =((char*)s) ;
  theValue->operator =("") ;
}


TString::TString(const char *s) : CString(s)
{ copyStr=0 ; iStr=0 ; }

int TString::getcpy()
{ unsigned char c ;
  if (!iStr || iStr->bad()) return -1 ;
  iStr->get(c) ;
  if (iStr->fail()) return -1 ;
  if (copyStr) { copyStr->put((char)c) ;
                 if (copyStr->fail())
                  { cerr << "!!! ERROR: Can't write to output file.\n" ;
                    exit(1) ; }
               }
  return(c) ;
}

int TString::getword()
{ int c=0 ; unsigned char *p ;
  if (!iStr) return 0 ;
  for(;;)
  {
    if (iStr->bad())
       { cerr << "!!! ERROR: Can't read from input file.\n" ; exit(1) ; }
    if (c<0) return 0 ;
    do { c=getcpy() ; }
     while ( c>0 && isspace(c)) ;
    if (c<0) continue ;
    if (c=='%')
      while (getcpy()!='\n' && iStr->good()) ;
    else
      if (c=='\\')
       { c=getcpy() ;
         if (c<0) continue ;
         if (isletter(c))
          while ((c=getcpy(),isletter(c)) && iStr->good()) ;
       }
      else
       if (c && isletter(c))
       { p=(unsigned char *)buf ; *p++=(unsigned char)c ;
         for(c=iStr->peek();c>0 && isletter(c);p++)
           { *p=(unsigned char)c ; getcpy() ; c=iStr->peek() ; }
         *p=0 ;
         CString::operator =(buf) ;
         if (p>(unsigned char *)buf) break ;
         }
  }
  return 1 ;
}
