// This is IMLOW.H
// Project IMARK - a support program for indexing TeX and LaTeX documents
// (C) Jan Kybic, 1993

// Main module is IMARK.CPP It contains also compile notes.

// In this module we implement all the major routines.
//  as methods of class List of Words

#ifndef _IMLOW_H
#define _IMLOW_H

#include <fstream.h>
#include <strng.h>
#include "bsortarr.h"
#include "csort.h"
#include "imclass.h"

// Macro to check if Object was allocated properly.

#define checkObject(o) \
  { if ((Object&)*(o)==NOOBJECT) { cerr << "!!! ERROR: Not enough memory.\n" ; \
                        exit(1) ; }}

// Appends extension to given filename. Does nothing if there is one.
void appendext(String& name,char *ext) ;

// Changes extension of a given name or appends it, if there is none.
void changeext(String& name,char *ext) ;

// Class ListOfWords is esentially sorted array. It maintains all necessary.

class ListOfWords : public BSortedArray
{ public:
   ListOfWords() : BSortedArray(5000,0,1000) {} ;
     // Constructor. Initially creates an array capable of holding 5000 words
     //  and expands it by 1000 if necessary. Can be changed.

   void readfrom(CString& name) ; // Read list of words from file 'name'
   void writeto(CString& name) ;  // Writes list of words to file 'name'
   void mark(CString& name) ;     // Marks TeX source file 'name'
                                  //  using words from the list of words
   void makelist(CString& name) ; // Makes list of words from TeX file 'name'

   virtual void printHeader(ostream& o) const
      { o << "% List of words for IMARK, (C) Jan Kybic 1993\n" ; } ;
                                  // Header that is written into LW file
   virtual void printSeparator(ostream&) const {} ; // no separator
   virtual void printTrailer(ostream& o) const      // and trailer
      { o <<"% End of the list\n" ; } ;
} ;

// Contains pointer to the instance of ListOfWords
extern ListOfWords *LW ;

extern CString *output_extension ; // contains extension for output files
extern CString *index_command ;    // contains index command
   // see command line switches -o, -c

#endif

// End of file IMLOW.H
